#!/bin/bash

# Runs as a filter.  Argument is flags of what to do or default chosen by us.

# Takes as input most any version of one sentence per line 4000qs.
# Returns a fixed version.

# The early changes are line-based and in Perl
# The later changes are tree-based and in Tsurgeon (Java)
# You need Tregex/Tsurgeon (and Perl and Java) installed and on your path or fill in the line below:

# You probably need to put a Tregex classpath here
# JAVAFLAGS=-cp /Users/manning/Software/stanford-tregex-2011-06-19/stanford-tregex.jar
JAVAFLAGS=

if [ $# -ne 0 ]
then
  ARG=$1
else
  # Best map of all 4000 questions
  ARG=$(( 1|2|4|8|16|32|128|256|512|1024|4096|8192|16384|32768 ))
  # Best map of 3924 questions, deleting those overlapping the Laura Rimell et al. test set
  # ARG=$(( 1|2|4|8|16|32|128|256|512|1024|2048|4096|8192|16384|32768 ))
fi
# echo "ARG is $ARG" 1>&2

SCRIPTDIR=`dirname $0`
TMPFILE1=`mktemp`

ARGS=""
if (( $ARG & 8192 ))
then
  ARGS="$ARGS $SCRIPTDIR/autofix8192.tsurgeon"
fi
if (( $ARG & 16384 ))
then
  ARGS="$ARGS $SCRIPTDIR/autofix16384.tsurgeon"
fi
if (( $ARG & 32768 ))
then
  ARGS="$ARGS $SCRIPTDIR/autofix32768.tsurgeon"
fi

if [ "$ARGS" == "" ]
then 
perl $SCRIPTDIR/autofix.pl $ARG
else
perl $SCRIPTDIR/autofix.pl $ARG > $TMPFILE1
java $JAVAFLAGS edu.stanford.nlp.trees.tregex.tsurgeon.Tsurgeon -s -treeFile $TMPFILE1 $ARGS
fi
